# PFactoryBase Class Reference

Base class for generic factories. More...

`#include <pfactory.h>`

Inheritance diagram for PFactoryBase:

List of all members.

## Public Member Functions

virtual | ~PFactoryBase ()
virtual void | DestroySingletons ()=0

## Static Public Member Functions

static FactoryMap & | GetFactories ()
static PMutex & | GetFactoriesMutex ()

## Protected Member Functions

| PFactoryBase ()

## Protected Attributes

PMutex | m_mutex

## Classes

class | FactoryMap

## Detailed Description

Base class for generic factories.

This classes reason for existance and the FactoryMap contained within it is to resolve issues with static global construction order and Windows DLL multiple instances issues. THis mechanism guarantees that the one and one only global variable (inside the GetFactories() function) is initialised before any other factory related instances of classes.

## Constructor & Destructor Documentation

PFactoryBase::PFactoryBase | ( |  | ) | `[inline, protected]`

virtual PFactoryBase::~PFactoryBase | ( |  | ) | `[inline, virtual]`

## Member Function Documentation

virtual void PFactoryBase::DestroySingletons | ( |  | ) | `[pure virtual]`

Implemented in PFactory< AbstractClass, KeyType >.

static FactoryMap& PFactoryBase::GetFactories | ( |  | ) | `[static]`

static PMutex& PFactoryBase::GetFactoriesMutex | ( |  | ) | `[static]`

## Member Data Documentation

PMutex PFactoryBase::m_mutex `[protected]`

The documentation for this class was generated from the following file:

- pfactory.h